<script lang="ts">
  import { getGroupProductAPI } from "src/apis/get-group-product";
  import { getProductByGroupAPI } from "src/apis/get-product-group";

  import { getProductByTypeAPI } from "src/apis/get-product-type";
  import { getProductsAPI } from "src/apis/get-products";
  import { getTypeProductAPI } from "src/apis/get-type-product";
  import type { ProductGroupModel } from "src/models/product.group.type copy";
  import { productGroupStore, productTypeStore } from "src/store";
  import { onMount } from "svelte";

  let select: string = "";

  onMount(async () => {
    await getTypeProductAPI();
    await getGroupProductAPI();
  });

  async function onClickProductType(typeName: string) {
    select = typeName;
    await getProductByTypeAPI(typeName);
  }

  async function getAllProduct() {
    await getProductsAPI();
    select = "";
  }

  async function onClickProductGroup(menu: ProductGroupModel) {
    select = menu.typeName;
    await getProductByGroupAPI(menu.querySearch);
  }
</script>

<div class="px-5">
  <div
    class="flex items-center py-0 px-5 h-16 leading-4 text-gray-800 bg-white border-b border-gray-200 border-solid"
  >
    <div
      class="flex-1 mr-5 text-base font-medium leading-5 text-gray-600 uppercase truncate"
    >
      <div class="flex text-gray-600 uppercase whitespace-no-wrap">
        <p
          class="block self-center leading-4 text-red-700 no-underline uppercase bg-transparent"
        >
          หมวดหมู่สินค้า
        </p>
      </div>
    </div>
    <div class="block text-gray-800 no-underline">
      <div
        class="flex overflow-visible justify-center items-center py-1 px-2 m-0 text-sm font-light tracking-normal leading-none text-center text-red-600 capitalize bg-transparent cursor-pointer hover:text-red-600"
        style="outline: none; transition: background-color 0.1s cubic-bezier(0.4, 0, 0.6, 1) 0s;"
      >
        <div class="flex items-baseline leading-3 no-underline capitalize">
          <div
            on:click={getAllProduct}
            class="flex items-baseline h-5 text-red-700 capitalize"
          >
            สินค้าทั้งหมด
            <div
              class="flex justify-center items-center ml-2 w-4 h-4 capitalize bg-red-700"
              style="border-radius: 50%;"
            >
              <svg
                enable-background="new 0 0 11 11"
                viewBox="0 0 11 11"
                x="0"
                y="0"
                class="inline-block relative w-2 h-4 capitalize"
                style="fill: currentcolor; stroke: rgb(255, 255, 255); font-size: 10px; line-height: 10px;"
              >
                <path
                  d="m2.5 11c .1 0 .2 0 .3-.1l6-5c .1-.1.2-.3.2-.4s-.1-.3-.2-.4l-6-5c-.2-.2-.5-.1-.7.1s-.1.5.1.7l5.5 4.6-5.5 4.6c-.2.2-.2.5-.1.7.1.1.3.2.4.2z"
                  class="capitalize"
                  style="font-size: 10px; line-height: 10px;"
                />
              </svg>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div>
    <div class="leading-4 bg-transparent cursor-pointer p-2 bg-gray-800 flex">
      <!-- Item -->
      {#each $productTypeStore as group}
        <div
          on:click={() => onClickProductType(group.typeName)}
          class="w-24 bg-white p-2 border hover:bg-gray-300 cursor-pointer {select ==
          group.typeName
            ? 'bg-red-500 text-white'
            : ''}"
        >
          <div
            class="mx-auto mt-4 mb-2 w-12 h-12 cursor-pointer"
            style="border-radius: 50%;"
          >
            <div class="relative h-full rounded-none">
              <div
                class="h-full bg-no-repeat bg-contain opacity-100"
                style="background-image: url('https://cf.shopee.co.th/file/44460b485585407b970f690cbe4e589b_xhdpi'); background-size: contain; background-repeat: no-repeat; transition: opacity 0.2s ease 0s;"
              />
            </div>
          </div>
          <div
            class="overflow-hidden mb-2 text-xs tracking-normal leading-5 text-center break-words"
          >
            {group?.typeName || "-"}
          </div>
        </div>
      {/each}
    </div>
  </div>
</div>

<!-- ************************** Group ************************* -->
<div class="px-5">
  <div
    class="flex items-center py-0 px-5 h-16 leading-4 text-gray-800 bg-white border-b border-gray-200 border-solid"
  >
    <p
      class="block self-center leading-4 text-red-700 no-underline uppercase bg-transparent"
    >
      กลุ่มสินค้า
    </p>
  </div>
  <div class="leading-4 bg-transparent cursor-pointer p-2 bg-gray-800 flex">
    <!-- Item -->
    {#each $productGroupStore as menu}
      <div
        on:click={async () => await onClickProductGroup(menu)}
        class="w-24 bg-white p-2 border hover:bg-gray-300 cursor-pointer {select ==
        menu.typeName
          ? 'bg-red-500 text-white'
          : ''}"
      >
        <div
          class="mx-auto mt-4 mb-2 w-12 h-12 cursor-pointer"
          style="border-radius: 50%;"
        >
          <div class="relative h-full rounded-none">
            <img
              src={menu.icon}
              class="h-full bg-no-repeat bg-contain opacity-100"
            />
          </div>
        </div>
        <div
          class="overflow-hidden mb-2 text-xs tracking-normal leading-5 text-center break-words"
        >
          {menu?.typeName || "-"}
        </div>
      </div>
    {/each}
  </div>
</div>
